ASPGestionProduit/Models/Utilisateur.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ASPGestionProduit.Models
{
    public class Utilisateur
    {

        private int id;
        private string nom;
        private string prenom;
        private string adresse;
        private string ville;
        private string codePostal;
        private Tpays pays;
        private string identifiant;
        private string mdp;
        private Role role;
        private List<Commentaire> commenatires;

   

        public int Id { get => id; set => id = value; }
        public string Nom { get => nom; set => nom = value; }
        public string Prenom { get => prenom; set => prenom = value; }
        public string Identifiant { get => identifiant; set => identifiant = value; }
        public string Mdp { get => mdp; set => mdp = value; }
        public Role Roles { get => role; set => role = value; }
        public string Adresse { get => adresse; set => adresse = value; }
        public string Ville { get => ville; set => ville = value; }
        public string CodePostal { get => codePostal; set => codePostal = value; }
        public List<Commentaire> Commenatires { get => commenatires; set => commenatires = value; }

        public Tpays Tpays { get => pays; set => pays = value; }

        public Utilisateur()
        {

        }
    }
}

ASPGestionProduit/Controllers/UtilisateurController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Security.Cryptography;
using System.Threading.Tasks;
using ASPGestionProduit.Interface;
using ASPGestionProduit.Models;
using ASPGestionProduit.Tools;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace ASPGestionProduit.Controllers
{
    public class UtilisateurController : Controller
    {

        private IHash _hash;
        private IFavori _fav;


        public UtilisateurController(IHash hash, IFavori fav)
        {

            _hash = hash;
            _fav = fav;
        }
        public IActionResult SignInForm()
        {

            List<Tpays> pays = Sauvegarde.Instance.GetListPays();

            ViewBag.pays = pays;
            List<Role> roles = Sauvegarde.Instance.GetRoles();

            return View(roles);
        }




        [HttpPost]
        public IActionResult SubmitSignIn([FromForm] Utilisateur utilisateur, int idRole, int idTpays)
        {
            Role role;

            if (idRole == 0)
            {

                role = new Role();
                role.Roles = Sauvegarde.Instance.GetRoleById(1).Roles;

            }else
            {

                role = Sauvegarde.Instance.GetRoleById(idRole);

            }
           
            Tpays pays = Sauvegarde.Instance.GetPaysById(idTpays);

            

            utilisateur.Tpays = pays;
            utilisateur.Roles = role;
            utilisateur.Mdp = _hash.GetHash(SHA256.Create(), utilisateur.Mdp);
            DataContext.Instance.Utilisateurs.Add(utilisateur);
            DataContext.Instance.SaveChanges();
            return RedirectToAction("FormLogin");
        }

        public IActionResult FormLogin()
        {
           

            return View();
        }

        




        [HttpPost]
        public async Task<IActionResult> SubmitLogin(string identifiant, string mdp)
        {
            string compareHash = _hash.GetHash(SHA256.Create(), mdp);
            Utilisateur utilisateur = DataContext.Instance.Utilisateurs.Include(u => u.Roles).Include(u => u.Tpays).FirstOrDefault(u => u.Identifiant == identifiant && u.Mdp == compareHash);
            if (utilisateur != null)
            {
                //Garder la connexion dans les sessions, ainsi que les informations des utilisateurs
                //_login.SaveUser(utilisateur);
                //Utilisation du login avec AuthenticationCookie
                List<Claim> claims = new List<Claim>()
                {
                    new Claim(ClaimTypes.Email, utilisateur.Identifiant),
                    new Claim(ClaimTypes.Name , utilisateur.Prenom),
                    new Claim(ClaimTypes.Role, utilisateur.Roles.Roles),
                 
                };
                ClaimsIdentity claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
                AuthenticationProperties option = new AuthenticationProperties()
                {
                    IsPersistent = true,
                    ExpiresUtc = DateTime.UtcNow.AddDays(1)
                };
                await HttpContext.SignInAsync(CookieAuthenticationDefaults.AuthenticationScheme, new ClaimsPrincipal(claimsIdentity), option);
                return RedirectToAction("Index", "Home");
            }
            return View("FormLogin");
        }

        public async Task<IActionResult> LogOut()
        {
            _fav.getFavoris().Clear();
            //HttpContext.Session.Clear();
            await HttpContext.SignOutAsync(CookieAuthenticationDefaults.AuthenticationScheme);
            
            return RedirectToAction("Index", "Home");
        }

        public IActionResult Denied()
        {

            return View();

        }

        public IActionResult GetListFavori()
        {

            List<Product> productsFavoris = new List<Product>();
            foreach (int id in _fav.getFavoris())
            {
                Product p = Sauvegarde.Instance.GetProdutcById(id);
                productsFavoris.Add(p);
            }

            return View("ListFavoris", productsFavoris);
        }

        public IActionResult AddFavori(int id)
        {
            bool isFav = false;

            if (_fav.getFavoris().Count > 0)
            {
                foreach (int idFav in _fav.getFavoris())
                {
                    if (idFav == id)
                    {
                        isFav = true;
                        break;
                    }
                    else
                    {
                        isFav = false;
                    }
                }

                if (isFav == true)
                {
                    _fav.RemoveFromFavoris(id);
                    Product product = Sauvegarde.Instance.GetProdutcById(id);
                    product.IsFav = false;
                    DataContext.Instance.SaveChanges();
                }
                else
                {
                    _fav.AddToFavoris(id);
                    Product product = Sauvegarde.Instance.GetProdutcById(id);
                    product.IsFav = true;
                    DataContext.Instance.SaveChanges();
                }
            }
            else
            {

                _fav.AddToFavoris(id);
            }
            return RedirectToAction("GetListFavori");
        }

    }




}


ASPGestionProduit/Views/Utilisateur/Denied.cshtml
<div class="card">
    <div class="card-header alert-danger">
        Error
    </div>
    <div class="card-body">
        <h5 class="card-title">Accès non authorisé</h5>
        <p class="card-text">Vous n'avez pas les droits pour accéder à cette page.</p>
        <a  asp-controller="Home" asp-action="Index"  class="btn btn-danger">Retour Accueil</a>
    </div>
</div>

ASPGestionProduit/Views/Utilisateur/FormLogin.cshtml
<h2>Login</h2>

<form enctype="multipart/form-data" method="post" asp-controller="Utilisateur" asp-action="SubmitLogin">
    <div class="row m-1">
        Votre Email
    </div>
    <div class="row m-1">
        <input type="text" class="col form-control" placeholder="Email" name="identifiant" />
    </div>
    <div class="row m-1">
        <input type="password" class="col form-control" placeholder="Password" name="mdp" />
    </div>
    <button type="submit" class="col btn btn-success m-2 w-auto">Valider</button>
    <a   asp-controller="Utilisateur" asp-action="SignInForm"  class="btn btn-primary">SignIn</a>
</form>

ASPGestionProduit/Views/Utilisateur/ListFavoris.cshtml
<div class="container">
    <h5 class="m-3">Liste des favoris</h5>
    @if (Model.Count > 0)
    {
        @foreach (Product p in Model)
        {
            <div class="row justify-content-lg-around mb-4">
                <div class="col">
                    <img src="@p.Images[0].Url" style="height:25vh; width:20vw;" />
                </div>
                <div class="col card w-75 pl-0 pr-0 justify-content-around">
                    <div class="card-header bg-info w-100 m-0 p-2">
                        <div class="row pl-4 pr-4">
                            <div class="row">
                                <div class="row m-1  w-100">
                                    <h4>@p.Categorie.Nom</h4> 
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <h4 class="card-title">@p.Titre</h4>
                        <h5 class="card-text">@p.Ean</h5>
                       <h5 class="card-text">@p.Prix <i class="fas fa-euro-sign"></i></h5>
                        <p class="card-text">@p.Description</p>
                    </div>
                    <div class="row justify-content-around mb-4">
                        <div class="justify-content-center"><a asp-controller="Home" asp-action="DetailProduct" asp-route-id="@p.Id" class="btn btn-primary">Ajouter Panier</a></div>
                        <div class="justify-content-center"><a asp-controller="Utilisateur" asp-action="AddFavori" asp-route-id="@p.Id" class="btn btn-warning">Supprimer</a></div>
                    </div>
                </div>

            </div>
        }
    }
    else
    {
        <div class="row">
            <div class="col alert-danger alert">
                Pas de favori pour le moment
            </div>
        </div>
    }

</div>


ASPGestionProduit/Views/Utilisateur/SignInForm.cshtml
@using System.Security.Claims;
@using Microsoft.AspNetCore.Http;
@inject IHttpContextAccessor _accessor
<div class="container">
    <h2 class="mb-3">Nouveau Utilisateur - Creer Compte</h2>
    <form enctype="multipart/form-data" method="post" asp-controller="Utilisateur" asp-action="SubmitSignIn">
        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="inputEmail4">Votre Nom</label>
                <input type="text" class="col form-control" placeholder="Nom" name="nom" />
            </div>
            <div class="form-group col-md-6">
                <label for="inputEmail4">Votre Prenom</label>
                <input type="text" class="col form-control" placeholder="Prenom" name="prenom" />
            </div>
            <div class="form-group col-md-6">
                <label for="inputEmail4">Email</label>
                <input type="email" class="col form-control" placeholder="Email" name="identifiant" />
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Password</label>
                <input type="password" class="col form-control" placeholder="Password" name="mdp" />
            </div>
        </div>
        <div class="form-group">
            <label for="inputAddress">Addresse</label>
            <input type="text" class="form-control" placeholder="1234 Main St" name="adresse">
        </div>
        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="inputCity">Ville</label>
                <input type="text" class="form-control" name="ville">
            </div>
            <div class="form-group col-md-4">
                <label for="inputState">Pays</label>
                <select name="idTpays" class="form-control">
                    @foreach (Tpays p in ViewBag.pays)
                    {
                        <option value="@p.Id">@p.PaysName</option>
                    }
                </select>
            </div>
            <div class="form-group col-md-2">
                <label for="inputZip">Code Postal</label>
                <input type="text" class="form-control" name="codePostal">
            </div>
        </div>
        @if(@_accessor.HttpContext.User.HasClaim(u => u.Type == ClaimTypes.Email) && (@_accessor.HttpContext.User.Claims.FirstOrDefault(u => u.Type == ClaimTypes.Role).Value) == "admin")
        {
            
                <div class="row ml-2">
                    <legend class="col-form-label">Roles</legend>
               
                    <div class="col">
                        @foreach (Role r in @Model)
                        {
                            <label class="row"><input class="m-2" type="radio" name="idRole" value="@r.Id"><div class="ml-2">@r.Roles</div></label>

                        }

                    </div>
           
                </div>
            }
            <button type="submit" class="col btn btn-success m-2 w-auto">Enregistrer</button>
        </form>
    </div>